// Hagop M. Harfoushian, AUBnet: hmh51, aubID: 201201447
// This is the rectangle data Type whose API and description is in the book.
// a rectangle is defined as a given point, and two "vectors" drawn perp. from it, called hight and width.
public class Rectangle {
	private int x;
	private int y;
	private int width;
	private int height;
	private Point p;

	public Rectangle(int initialX, int initialY, int initialWidth, int initialHeight){
		x = initialX;
		y = initialY;
		width = initialWidth;
		height = initialHeight;
		if(height <= 0 || width <= 0) System.out.println("Error");
	}
	public int getHeight(){
		return height;
	}
	public int getWidth(){
		return width;
	}
	public int getX(){
		return x;
	}
	public int getY(){
		return y;
	}
	public String toString(){
		String s = "Rectangle[x="+x+", y="+y+", width=" + width +", height="+height+"]";
		return s;
	}
	public Rectangle(Point p2, int initialWidth, int initialHeight){
		x = (int)p2.getX();
		y = (int)p2.getY();
		width=initialWidth;
		height= initialHeight;
		p=p2;
	}
	public Point getPoint(){
		Point p2 = new Point(p.getX(),p.getY());
		return p2;
	}
	public boolean contains(int initialX, int initialY){
		if(initialX<=x && initialY<=y)
			return true;
		else 
			return false;
	}
	public boolean contains(Point p){
		int a = (int)p.getX();
		int b = (int)p.getY();
		if(a>=x && b>=y && a<=x+width && b<=y+height)return true;
		else return false;
	}
	public Rectangle union(Rectangle r)
	{
		int x2 = r.getX();
		int y2 = r.getY();
		int w2 = r.getWidth();
		int h2 = r.getHeight();
		int union_X = Math.min(x,x2); // the upper most left point (taking the origin in the buttom left)
		int union_Y = Math.min(y, y2);
		int union_W = Math.max(width+x, w2+x2)-union_X; // max width from the 1st rectangle to the second.
		int union_H = Math.max(height+y,h2+y2)-union_Y;//  max height from the 1st rectangle to the second.
		Rectangle union = new Rectangle (union_X,union_Y,union_W,union_H);
		return union;
	}
	public Rectangle intersection(Rectangle rect)
	{
		int w2 = rect.getWidth();
		int x2 = rect.getX();
		int h2 = rect.getHeight();
		int y2 = rect.getY();
		int inter_X = Math.max(x,x2);// x intersection
		int inter_Y = Math.max(y,y2);// y intersection
		int inter_Width = Math.min(width+x, w2+x2)-inter_X;// min width from the 1st rectangle to the second.
		int inter_Height = Math.min(height+y, h2+y2)-inter_Y;// min height from the 1st rectangle to the second.
		Rectangle intersection = new Rectangle (inter_X,inter_Y,inter_Width,inter_Height);
		return intersection;
	}
}

