// Hagop M. Harfoushian, AUBnet: hmh51, aubID: 201201447
// this is a Segment data type whose API is the description in the book p.575, exc. 9-12.
public class Segment {
	private int x1;
	private int y1;
	private int x2;
	private int y2;

	public Segment(Point p1, Point p2){
		x1=(int) p1.getX();
		y1=(int) p1.getY();
	}
	public Segment(int PassedX1, int PassedY1, int PassedX2, int PassedY2){
		x1=PassedX1;
		y1=PassedY1;
		x2=PassedX2;
		y2=PassedY2;
	}
	public Point getP1(){
		return new Point(x1, y1); 
	}
	public Point getP2(){
		return new Point(x2, y2);
	}
	public String toString(){
		return "[(" + x1 + ", " + y1 + ")" + ", (" + x2 + ", " + y2+ ")]"; 
	}
	public double getSlope(){
		double slope=(y2-y1)/(x2-x1);
		return slope;
	}	
	public boolean isCollinear(Point p){
		Point p1=new Point(x1, x2);
		Segment newSeg= new Segment (p1, p);
		if ((p.getX()==x1 && p.getY()==y1) || (p.getX()==x2 && p.getY()==y2)) // if p is the same point(defining the segment)
			return true;
		else if(round(newSeg.getSlope())==round(((y2-y1)/(x2-x1))))
				return true;
		else
			return false;
	}
	public static double round(double d){ // round to the nearest ten thousandth.
		double n=d;
		n*=10000;
		n=Math.round(n);
		n/=10000;
		return n;
	}
}
